BEGINNING-OF-PROGRAM

  DEFINE-NEW-INSTRUCTION turnright AS
  BEGIN
    ITERATE 3 TIMES
      turnleft
  END;

  DEFINE-NEW-INSTRUCTION turnaround AS
  BEGIN
    turnleft;
    turnleft
  END;

  DEFINE-NEW-INSTRUCTION face-west AS
  BEGIN
    WHILE not-facing-west DO
      turnleft
  END;

  DEFINE-NEW-INSTRUCTION face-south AS
  BEGIN
    WHILE not-facing-south DO
      turnleft
  END;

  DEFINE-NEW-INSTRUCTION face-east AS
  BEGIN
    WHILE not-facing-east DO
      turnleft
  END;

  DEFINE-NEW-INSTRUCTION zig-left-up AS
  BEGIN
    move;
    turnright;
    move;
    turnleft
  END;

  DEFINE-NEW-INSTRUCTION zag-down-right AS
  BEGIN
    move;
    turnleft;
    move;
    turnright
  END;

  DEFINE-NEW-INSTRUCTION advance-to-next-diagonal AS
  BEGIN
    IF facing-west
      THEN turnright
      ELSE turnleft;
    move;
    turnaround
  END;

  DEFINE-NEW-INSTRUCTION zig-move AS
  BEGIN
    IF front-is-clear
      THEN zig-left-up
      ELSE advance-to-next-diagonal
  END;

  DEFINE-NEW-INSTRUCTION zag-move AS
  BEGIN
    IF front-is-clear
      THEN zag-down-right
      ELSE advance-to-next-diagonal
  END;

  DEFINE-NEW-INSTRUCTION find-beeper AS
  BEGIN
    face-west;
    WHILE not-next-to-a-beeper DO
      IF facing-west
        THEN zig-move
        ELSE zag-move
  END;

  DEFINE-NEW-INSTRUCTION compute-sum AS
  BEGIN
    face-south;
    WHILE front-is-clear DO
      zag-down-right;
    face-east;
    move
  END;

  BEGINNING-OF-EXECUTION
    find-beeper;
    pickbeeper;
    compute-sum;
    putbeeper;
    turnoff
  END-OF-EXECUTION
END-OF-PROGRAM
